/*
** List all records in the look up table
** Class: ViewTable
** Author: Yuping Zhu
** Date: 04-08-1999
*/

package ascdb.admin;

// import package java.sql to use JDBC
import java.sql.*;

// import package oracle.html to generate dynamic HTML page
import oracle.html.*;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;

import ascdb.conf;
import ascdb.pub.UserCheck;
import java.text.Collator;

public class ViewTable extends HttpServlet {
     public void doPost(HttpServletRequest req, HttpServletResponse res)
        throws ServletException, IOException
    {
	// Output HTML page header
        res.setContentType("text/html");
        PrintWriter out = res.getWriter();
	conf dbconf = new conf(req);
	String me = req.getParameter("me");
	UserCheck u = new UserCheck(me);
	String TableName = req.getParameter("name");
	int op = (new Integer(req.getParameter("op"))).intValue();
	
//	out.println(TableName);
	try {
	   if ((u.UserRole(1) != 0) & !((u.UserRole(2) == 0) & (op == 1)))
	   {
		out.println("You have no privilege!");
		return;
	   }
	

	   // Load the Oracle JDBC driver
	   Class.forName (dbconf.JdbcDriver);
	
	   // Connect to the database
 	   Connection conn =
    		DriverManager.getConnection (dbconf.ConnectStr,dbconf.DBName,dbconf.DBPassword);

	   // Create a Statement
	   Statement stmt = conn.createStatement ();

	   // Check if there is record in the table
	   ResultSet rset1 = stmt.executeQuery("select count(*) from " + TableName);
	   int tot = 0;
	   if (rset1.next())
	   {
		tot = rset1.getInt(1);
		if (tot == 0)
		{
			out.println("There is no record in look up table: " + TableName);
			return;
		}
	   }
	   rset1.close();
		 
	   // Creates an HtmlHead Object
            HtmlHead hd = new HtmlHead("View look up table: " + TableName);
        
           // Create an HtmlBody Object
           HtmlBody bd = new HtmlBody();

           // Sets various attributes of HtmlBody
           bd.setBackgroundColor("#fffff2");
             
           // Creates an HtmlPage object using hd and bd
           HtmlPage hp = new HtmlPage(hd, bd);
 
	   // Select All rows from look up table
	   String QueryString = "select * from " + TableName;
  	   ResultSet rset;
	   Collator cl = Collator.getInstance();


	   String tit1 = "Country Abbreviation";
	   String tit2 = "Country Name";
	   String Column1 = "country_abbr";
//	   String Column2 = "country_nam";
	   int falg = 1;
	   if (cl.equals(TableName,"v_states"))
	   {
	 	Column1 = "state";
//		Column2 = "state_nam";
		tit1 = "State Code";
		tit2 = "State Name";
	   }

	   if (cl.equals(TableName,"v_surtitles"))
	   {
	     hp
		.addItem(new SimpleItem("All Records of Look Up Table: " + TableName).setFontColor(Color.olive).setBold())
                .addItem(SimpleItem.HorizontalRule)
                .addItem(new SimpleItem("Total record: " + tot).setItal().setFontColor(Color.red).setBold())
		.addItem(SimpleItem.Paragraph);

	     rset = stmt.executeQuery(QueryString+ " order by surtitle asc");
	     while(rset.next())
	     {
 	        if ( op == 1)
		     hp.addItem(new SimpleItem(rset.getString(1)));
		else if (op == 3)
		     hp.addItem(new Link("ascdb.admin.ModifyRow?op=1&name=" + TableName + "&me=" + me + "&id=" + rset.getString(1), new SimpleItem(rset.getString(1)).setBold()));
		else if (op == 4)
		     hp.addItem(new Link("ascdb.admin.DeleteRow?op=1&name=" + TableName + "&me=" + me + "&id=" + rset.getString(1), new SimpleItem(rset.getString(1)).setBold()));
	        hp.addItem(SimpleItem.LineBreak);
	     }
	     out.println(hp);
	     return;
	   }		

	   
	   rset = stmt.executeQuery(QueryString + " order by " + Column1 + " asc");
	   DynamicTable tab = new DynamicTable(2);
           tab.setBackgroundColor (Color.pink);
           tab.setBorderColor (Color.navy);
           tab.setCellSpacing(2);
           tab.setCellPadding(5);

	   TableRow[] rows = new TableRow[tot + 1];
           for(int i=0; i <= tot; i++)
                rows[i] = new TableRow();
		
	   rows[0]
               .addCell(new TableDataCell(new SimpleItem(tit1).setBold().setFontColor(Color.maroon))) 
               .addCell(new TableDataCell(new SimpleItem(tit2).setBold().setFontColor(Color.maroon)));
	   int i = 1;
	   while(rset.next())
	   {
	     if (op == 1)
	        rows[i]
		   .addCell(new TableDataCell(new SimpleItem(rset.getString(1))));  
	     else if ( op == 3)
		rows[i]
		   .addCell(new TableDataCell(new Link("ascdb.admin.ModifyRow?op=1&name=" + TableName + "&me=" + me + "&id=" + rset.getString(1), new SimpleItem(rset.getString(1)).setBold()))); 
	     else if ( op == 4)
		rows[i]
		   .addCell(new TableDataCell(new Link("ascdb.admin.DeleteRow?op=1&name=" + TableName + "&me=" + me + "&id=" + rset.getString(1), new SimpleItem(rset.getString(1)).setBold()))); 
	     rows[i++]
                .addCell(new TableDataCell(new SimpleItem(rset.getString(2))));
	   }
	   
	    hp
		.addItem(new SimpleItem("All Records of Look Up Table: " + TableName).setFontColor(Color.olive).setBold().setCenter())
                .addItem(SimpleItem.HorizontalRule)
                .addItem(new SimpleItem("Total record: " + tot).setItal().setFontColor(Color.red).setBold().setCenter());
	
           // Add new row to table
           for(i=0; i<  tot + 1; i++)
              tab.addRow(rows[i]);
             
           // Add the table to Html Body
           bd.addItem(tab.setCenter());
             
           bd
              .addItem(SimpleItem.Paragraph)
              .addItem(SimpleItem.HorizontalRule)
              .addItem(SimpleItem.Paragraph);


	   // output HTML page
           out.println(hp); 
           }
           catch(ClassNotFoundException e) {
                 out.println("Couldn't load database driver: " + e.getMessage());
           }
           catch (SQLException e) { 
                out.println(e.getMessage());
           }
	   catch(Exception e) {
		out.println(e.getMessage());
	   }
   }
}